#ifndef I2C_KEY_H
#define I2C_KEY_H	1

uint8_t get_key_press( uint8_t );
uint8_t get_key_rpt( uint8_t );
uint8_t get_key_short( uint8_t );
uint8_t get_key_long( uint8_t );
uint8_t test_i2c_key(void);
void timer2_init(void);

#include "bits.h"
#define ALL_KEYS       	(1<<KEY_ESC | 1<<KEY_UP | 1<<KEY_LEFT | 1<<KEY_RIGHT | 1<<KEY_DOWN | 1<<KEY_ENTER /*| 1<<KEY_7 | 1<<KEY_8*/)
 
#define REPEAT_MASK     (1<<KEY_UP | 1<<KEY_LEFT | 1<<KEY_RIGHT | 1<<KEY_DOWN)   // (1<<KEY1 | 1<<KEY2)    // repeat: key1, key2
#define REPEAT_START    50                        // after 500ms
#define REPEAT_NEXT     15                        // every 200ms

#define PCF8574A_0  		0x70    // device address of PCF8574, see datasheet
#define PCF8574_0 		0x40    // device address of PCF8574, see datasheet
 
extern volatile uint8_t key_state;                         // debounced and inverted key state:
                                                  // bit = 1: key pressed
extern volatile uint8_t key_press;                         // key press detect
 
extern volatile uint8_t key_rpt;  	                      // key long press and repeat

extern volatile uint8_t _i2c_key;


#endif // #ifndef I2C_KEY_H
