// timer2_104.c

// AVR Memory Usage
// ----------------
// Device: atmega644
// Program:   45574 bytes (69.5% Full)
// (.text + .data + .bootloader)
// Data:       2947 bytes (71.9% Full)
// (.data + .bss + .noinit)
// Build succeeded with 0 Warnings...
// ----------------
// Device: atmega1284p
// Program:   45712 bytes (34.9% Full)
// (.text + .data + .bootloader)
// Data:       2947 bytes (18.0% Full)
// (.data + .bss + .noinit)
// Build succeeded with 0 Warnings...


#include <avr/interrupt.h>
#include <ctype.h>
#include <inttypes.h>
#include <avr/io.h>
#include <avr/pgmspace.h>
#include <avr/sleep.h>
#include <string.h>
#include <util/delay.h>

#ifndef MY_TYPES_H_
	#include "my_types.h"
#endif

#include "bits.h"
#include "calen.h"
#include "dcf77.h"
#include "i2cmaster.h"
#include "i2c_rtc.h"
#include "i2c_key.h"

#ifdef NEW_IRMP //in bits.h
#include "irmp\irmp.h"
#include "irmp\irsnd.h"
#else
#include "irmpconfig_.h"
#include "irmp_.h"
#include "irsnd_.h"
#endif

#include "ir_drv.h"
#include "lcd6.h"
#include "menu.h"
#include "programs.h"
#include "rc5.h"
#include "s_tools.h"
#include "uart.h"
#include "my_strings.h"

#ifndef ALARM_int1_PORT					//jar rep weil key1 kaputt
#define ALARM_int1_DDR		DDRD
#define ALARM_int1_PORT 	PORTD		// port for DCF_LED
#define ALARM_int1_PIN 	PIND		// port for DCF_LED
#define _ALARM_int1_pin		3       	// pin  for DCF_LED
#endif

IRMP_DATA irmp_data;

//http://blog.cc-robotics.de/2009/03/20/einstellungen-im-eeprom-eines-avr-speichern/
#define MAXDEVICENAMELEN   8
#define MAXKEYNAMELEN      8
#define MAXDEVICE   			6
#define MAXKEYS				30

typedef struct
{
   char			devices;
   char  		keyname[MAXKEYNAMELEN + 1];
   IRMP_DATA 	irmp_data;
} EXT_IRMP_DATA;

EXT_IRMP_DATA ext[MAXDEVICE][MAXKEYS];
char devicename[MAXDEVICE][MAXDEVICENAMELEN+1]={ "DVD1_Ch0", "DVD2_Ch19", "40zoll", "19zoll", "Pana_TV", "CRT" };

/*
EXT_IRMP_DATA  ext;
	...
	strcpy (ext.devicename, "TV");
  	strcpy (ext.keyname, "Volume+");
  	ext.irmp_data.protcol = IRMP_SAMSUNG_PROTOCOL;
  	ext.irmp_data.address = 0x0012;
  	ext.irmp_data.command = 0x0034;
  	ext.irmp_data.flags   = 0;
*/


UWORD 	p_old=0, i_=0, L_Com=0, Old_L_Com=0;
UBYTE show_irmp=0;

char __buildtime__[9];
char __builddate__[12];

char s[22], s2[22], gg;
volatile UWORD count__=0;
volatile UBYTE count2__=(UBYTE)(F_INTERRUPTS/100L);
volatile UBYTE _1_4_count=3;
volatile UBYTE _ms10=0;
volatile UBYTE _ms10_i2c_read_once_wunsch=0;
volatile UBYTE _ms10_i2c_read_once_true=0;

//TEST_PORT ^= (1<<_test);
volatile BOOL 	bedient=FALSE;

UBYTE	res_key=0;
UBYTE cam=0;
UBYTE	_dcfBIT;
UBYTE	ms10count=0;
volatile ULONG	fast_it=0;
volatile UBYTE sek10;
volatile UBYTE wait_sec; 
BOOL alarm_set=FALSE;
UWORD merke_rc5;
BOOL upd_ms10_adc=TRUE;
BOOL upd_ms10_lcd=TRUE;

UBYTE ms10_adc=0;
UBYTE ms10_lcd=0;

extern volatile UWORD 	_beep500ms;
extern volatile UBYTE 	ms_powerLED_flag;
extern volatile UBYTE 	ms_speedLED_flag;
extern volatile UBYTE 	ms_irLED_flag;
extern volatile UBYTE 	ms_dcfLED_flag;
extern volatile UBYTE 	ms_ausloes_flag;
extern volatile UBYTE 	ms_prefocus_flag;
extern volatile UBYTE 	ms_wakeup_flag;
extern volatile UBYTE 	ms_sva_flag;

volatile uint8_t i2c_test_flags;
volatile uint8_t _timerlaeuft=FALSE;

#ifdef TEST_
volatile uint8_t test=1;
#endif
uint8_t	_i2c_dcf_in;
uint8_t	_i2c_10ms_in;

extern uint8_t kon;
extern uint8_t hell;
extern uint8_t _beep_;

extern struct _NEWTIME newtime;
extern const char blenden[];
extern const unsigned zeit[];
extern const char *zeit_str[];

UBYTE __f=_CAM_AV_START;
UBYTE __tv=_CAM_TV_START;
UBYTE __tv_hilf=0;

uint8_t set_flags=0;

#ifndef F_CPU
#error F_CPU unkown
#endif

//#define IR_FREQUENZ 36000L

//PROGMEM char pic1[] = LOGO;


#define WAIT_A_BISSL 250


uint8_t timeflags;
uint8_t dcf77_period=0, alte_dcf77_period;
uint8_t dcf77_pulse, alte_dcf77_pulse;
#define ONE_TICK	0
#define ONE_SECOND	1
#define ONE_MINUTE	2


uint8_t dcf77_time, old_dcf77;
uint8_t woher=0, _merke_beep20=0;

void __tab(void);
void scr_up(void);
void scr_down(void);

uint8_t 	check_ms=1;
BOOL 	not_checked=FALSE;
volatile uint8_t line_=1, beginn_=0;

volatile uint8_t 	__p=_HAUPTMENU, _tab=1;
UWORD 	count=0, p_tab=0;
volatile ULONG time1_;
volatile ULONG time2_;

volatile UBYTE __hour=0;
volatile UBYTE __minute=0;
volatile UBYTE __day=0;
volatile UBYTE __month=0;
volatile UWORD __year=0;

ULONG 	_hk_sec=0;

// p11 datumsumschaltung uhr status
BOOL d_flag=FALSE;
BOOL next_second=FALSE;

// cam parameter
BOOL 	_wakeup=FALSE;
BOOL 	_wake=TRUE;

// von _darkframe genutzt
volatile ULONG	w4=0;

// Cam Parameter
uint8_t		_autopower=2;
BOOL 		__sva=FALSE;
uint8_t 	_rausch=1;
// von ausloesung genutzt
//_eeprom.cam_delay=_CAM_DELAYx10MS;
//UWORD 	cam_delay=_CAM_DELAYx10MS; bald gebraucht wenn aus den EEPROM geholt, noch per preprozessor als define

// TimerParameter
volatile BOOL war_alarm=FALSE;

char rtc_string[41];

ULONG hilf_=0;

extern char 	p3_cnt[];

// von ausloesung genutzt
volatile ULONG	w0=0;
volatile ULONG	last_cam_action=0;

// von DCF77 LCD Symbol genutzt
volatile BOOL 	setze=FALSE;
volatile BOOL 	gesetzt=FALSE;
volatile UWORD 	_500ms=0;

//BOOL 	p8_stat=FALSE;
BOOL 	p8_stat=TRUE;

BOOL 	p8_stat_merke=FALSE ;

// von p9 (3.Uhr) genutzt
BOOL  	res_p9=FALSE;

// von p10 (10.TimerSetting) genutzt
volatile uint8_t	h_beginn_p10=0;
volatile uint8_t	h_line_p10=1;
UWORD cpu_idle;
volatile uint8_t _p_run=0;

volatile BOOL	_darkframe=FALSE;
volatile BOOL	_darkframe_ende=FALSE;

BOOL 	merke_sva;

extern uint8_t 	__bi1;
extern uint8_t 	__bi2;
extern uint8_t 	__vo1;
extern ULONG 		__vo2;
extern uint8_t 	__zw1;
extern ULONG 		__zw2;

#include "timer0_isr.c"
#include "timer3_init.c"


ISR(TIMER3_OVF_vect)
{	static uint8_t ct0, ct1, rpt;
	uint8_t i=0;
//-------------
//  static uint8_t dcf77_time, old_dcf77;
//-------------
	cli();			// 30-250s
	TCNT3 = -76;
	_ms10++;
	fast_it++;
	_500ms++;

	if(ms10_lcd)
	{	ms10_lcd--;
		if(!ms10_lcd)
			upd_ms10_lcd=TRUE;
	}

	if(ms10_adc)
		ms10_adc--;
	else
		upd_ms10_adc=TRUE;

	if(ms_prefocus_flag)
	{	ms_prefocus_flag--;
		if(!ms_prefocus_flag)
		{	if(ms_ausloes_flag)
				AUSL_LED_PORT |= (1 << _camAUS);
			else
				AUSL_LED_PORT &= ~(1 << _camAF);
		}
	}
	else
	{	if(ms_ausloes_flag)
		{	ms_ausloes_flag--;
			if(!ms_ausloes_flag)
				AUSL_LED_PORT &= ~(1 << _camAUS | 1 << _camAF);
		}
	}

	if(_darkframe)
		if(fast_it>w4)
		{	_darkframe=FALSE; _darkframe_ende=TRUE; } // _darkframe fertig

	if( _blinker && (_p_run>=_BILDSERIE && _p_run<_LICHT) && _p_run==__p )
	{	if(!(SPEED_LED_DDR & (1<<_speedLED)))		
			SPEED_LED_DDR |= (1<<_speedLED);		
		if(_bli_count)
		{	if(_bli_on)
			{	_bli_on--;
				if(!_bli_on)
				{	SPEED_OFF;
					if(_merke_count==_ONCE)
						_bli_off=99-_ONTIMEx10ms;
					else
						_bli_off=_OFFTIMEx10ms;
				}
			}
			if(_bli_off)
			{	_bli_off--;
				if(!_bli_off)
				{	_bli_count--;
					if(_bli_count)
					{	SPEED_ON;
						_bli_on=_ONTIMEx10ms;
					}
					else
					{	_vo_tmp--;
						_bli_set=FALSE;
					}
				}
			}
		}
	}

	if(KoHe_flag)
		KoHe_flag--;

	if(ms_powerLED_flag)
	{	ms_powerLED_flag--;
		if(!ms_powerLED_flag)
			gruenLED(TOGGLE);	
	}

	if(ms_speedLED_flag)
	{	ms_speedLED_flag--;
		if(!ms_speedLED_flag)
			speedLED(TOGGLE);
	}

	if(ms_irLED_flag)
	{	ms_irLED_flag--;
		if(!ms_irLED_flag)
			irPOWER(ON);
	}

	if(ms_dcfLED_flag)
	{	ms_dcfLED_flag--;
		if(!ms_dcfLED_flag)
			gelbLED(SET);
	}

	if(_beep_count)
		if(_beep500ms)
		{	_beep500ms--;
			if(!_beep500ms)
			{	beep(FALSE);
				if(_beep_count<255)
				{	_beep_count--;
					if(!_beep_count)
					{	set_flags &= ~(1 << _BEEPER);
						_beep500ms=0;
						BEEPER_PORT	&= ~(1 << _BEEPER);
					}
				}
			}
		}

	if(wait_hell_flag)
		wait_hell_flag--;

#include "i2c_key_tst.c"
#include "dcf77_tst.c"

	sei();
}

#include "menu.c"
#include "fb.c"
#include "flags.c"

extern void irmp_uart_putc(char);
extern const char DISPLAY_INIT[];
volatile uint8_t save_rtc_status=0;

int main (void)
{
	//char buff[9];
	UBYTE blinki, _hell_perc, merke__p;//, altetaste=0;		//, sek;//, t0_lauft=0;//

	UBYTE u_count, __i, gz_cnt;
	UWORD Ub, Ib, ubat, new_stat_grenze, off;
	
	ULONG prog_beginn;
	ULONG alarm_beginn;
	ULONG alarm_zeit;
	ULONG dcf_timeout/*, _ulongdate*/;
	ULONG g_zeit;
	BOOL alarm_wakup=FALSE;

	ULONG mAh;

	UWORD ub, _ibat;

#if IRMP_LOGGING != 0       // 1: log IR signal (scan), 0: do not (default)
	char temp2[255];//, c1=0;
	char temp2_bak[255];
#endif
	char UI_str[LCD_DISP_LENGTH+1]={0};//, c1=0;

	save_rtc_status=0;

neustart:

	__tv=20;
	__tv_hilf=0;

	strcpy(__buildtime__,__TIME__);
	strcpy(__builddate__,__DATE__);

	blinki=0; sek10=0; _hell_perc=0; res_key=0; merke_rc5=0; ub=0; _ibat=0; UI_str[0]=0, show_irmp=0, wait_sec=0; 

	u_count=0; __i=0;
	Ub=0; Ub=0; Ib=0; ubat=0; new_stat_grenze=0; cpu_idle=0; Ib=0; ubat=0; off=0; new_stat_grenze=0;

	prog_beginn=0; alarm_beginn=0; alarm_zeit=0; mAh=0; dcf_timeout=_DCFTIMEOUT;
	fast_it=0;
	bedient=FALSE;

#if IRMP_LOGGING != 0       // 1: log IR signal (scan), 0: do not (default)
	temp2[0]=0;
#endif

	set_sleep_mode(SLEEP_MODE_PWR_DOWN); // sieht man ! NEUSTART
	EICRA |=1<<ISC10;
	EICRA |=1<<ISC11;

	cli();
	PCMSK3&=~(1<<PCINT27);
	PCICR&=~(1<<PCIE3);

	timer0_init();		// init timer0 fur IR 			-> s_tools_small2.c
	timer3_init();		// init timer3 fur ms10 & key -> i2c_key.c
	irmp_init ();		// initialize IR 					-> irmp.c
   irsnd_init();                                                             // initialize irsnd

	init_clock(BUILD);	// __clock.c

	i2c_init();			// initialize I2C 				-> i2cmaster.c
	test_i2c_key();

	/* initialize display, cursor off */
	lcd_init(LCD_DISP_ON);  // LCD_DISP_ON_CURSOR_BLINK
	
	test_i2c_rtc();
	if(_test_i2c_rtc)
		if(alarm_wakup)
			alarm1_clr_rtc();

	gesetzt=FALSE;
	setze=FALSE;
	_500ms=0;


sei();

	all_led(RESET);
_delay_ms(200);

	all_led(10);
_delay_ms(200);
	all_led(10);
_delay_ms(200);


uart_init(9600);
uart_puts_p("hello world 9600 Baud \r\n");

#if IRMP_LOGGING != 0       // 1: log IR signal (scan), 0: do not (default)
	uart_init(UART_BAUD_SELECT(9600,F_CPU));
#endif

	DCF_LED_DDR		|= (1<<_dcfLED);				// gelbLED Anode output
	DCF_LED_PORT 	|= (1 << _dcfLED);			// gelbLED Anode high
	DCF77_DDR 		&= ~(1<<DCF77);		// gelbLED Kathode input
	DCF77_PORT 		|= (1<<DCF77);		// gelbLED pullup enable

	DCF_VCC_DDR 	|= (1<<_dcfVCC);				// DDR for DCF_VCC output
	DCF_VCC_PORT 	|= (1 << _dcfVCC);			// port for DCF_VCC high

	AUSL_DDR |= (1 << _camAUS | 1 << _camAF);
	AUSL_LED_PORT &= ~(1 << _camAUS | 1 << _camAF);

	irPOWER(ON);

	CLS();
	menu();

{	ALARM_int1_DDR &= ~(1<<_ALARM_int1_pin);		// ALARM_int1_DDR auf in
	ALARM_int1_PORT |= (1<<_ALARM_int1_pin);			// ALARM_int1_PORT pullup enable
}

// LOOP ************************************ HAUPTSCHLEIFE ************************************
	for (;;)
	{	
// --- Timer1 ---
		cli(); //Global Interrupt Disable
	   i_ = rc5_data;			// read two bytes from interrupt !
	   rc5_data = 0;
	   sei(); //Global Interrupt Enable
// --- Timer2 ---
		scan_dcf77();

		if(__p!=_IRMP)
			fb();
		if(!res_key)
			res_key=get_key_press( ALL_KEYS );

		if(res_key)
	  		bedient=TRUE;
/*
if( __p>=_BILDSERIE && __p<_LICHT)
{
lcd_gotoxy(0,6); 
(_blinker) ? lcd_putc('1') : lcd_putc('0');
lcd_puts("_ph"); 
lcd_putc('0'+_prg_ph);
lcd_putc('/');
lcd_putc('0'+_bli_count);
lcd_putc('/');
lcd_putc('0'+_vo_tmp-1);
lcd_putc('/');
lcd_putc('0'+_bi_tmp);
lcd_gotoxy(12,6); (_p_run==__p) ? lcd_puts("luft ") : lcd_puts("wartet");
lcd_putc('0'+_p_run);lcd_putc('/');lcd_putc('0'+__p);
}
*/

		#include "if_upd_ms10_adc.c"
		#include "if_1sek.c"

		if(__p==_HAUPTMENU)
			#include "if(__p_HAUPTMENU).c"		
		// if(__p==_HAUPTMENU)
		else // -> __p !=_HAUPTMENU)
			#include "else(__p_HAUPTMENU).c"		

		if(res_key & (1<<KEY_LEFT) || res_key & (1<<KEY_RIGHT))
			__tab();

		if(res_key & ( 1<<KEY_ENTER ) && ( __p>=_BILDSERIE && __p<_LICHT ) )	
		{	if(_p_run!=__p)
			{
				_p_run=__p;
				switch(__p)
				{	case _BILDSERIE:
						_Bildserie();
						break;
					case _BEL_SERIE:
						_Bel_Serie();
						break;
					case _ZUFALLSBILDER:
						_Zufallsbilder();
						break;
					default:
						break;
				}
			} // if(_p_run)
			else
			{
				_p_run=0;
				_prg_ph=0;
				res_key=0;
				SPEED_OFF;
			}
			
//			lcd_gotoxy(12,6); (_p_run==__p) ? lcd_puts("luft ") : lcd_puts("wartet");
//			lcd_putc('0'+_p_run);lcd_putc('/');lcd_putc('0'+__p);

			res_key=0;
		}

		if( __p>=_BILDSERIE && __p<_LICHT && (res_key & (1<<KEY_LEFT) || res_key & (1<<KEY_RIGHT) || res_key & (1<<KEY_ENTER)))
		{	
			p_tab=__p*10+_tab;
			switch(p_tab)
			{	case _3VORLAUF:
					lcd_gotoxy(19,2);
					break;
				case _3ANZAHL: 
					lcd_gotoxy(19,3);
					break;
				case _3ZW_ZEIT: 
					lcd_gotoxy(19,4);
					break;
				case _3BLINKER: 
					lcd_gotoxy(19,5);
					break;

				case _4VORLAUF:		//__vo2 Vorlauf 4.Bel.serie
					lcd_gotoxy(12,2); 
					break;
				case _4ANZAHL: 
					lcd_gotoxy(11,3);
					break;
				case _4TV_ANF_ZEIT: 
					lcd_gotoxy(20,2);
					break;
				case _4SVA: // __sva
					lcd_gotoxy(6,1);
					break;
				case _4RAUSCH: // _rausch
					lcd_gotoxy(20,1);
					break;
				case _4AV: // __sva
					lcd_gotoxy(20,3);
					break;

				case _5RANDOM: 
					lcd_gotoxy(14,2);
					break;

				default:
					break;
			}	
			if(_p_run==__p)
			{	lcd_putc(' ');
			} // if(_p_run!=__p)
			else
			{	_p_run=0;
				lcd_putc('_');
			}

//			lcd_gotoxy(12,6); (_p_run==__p) ? lcd_puts("luft ") : lcd_puts("wartet");
//			lcd_putc('0'+_p_run);lcd_putc('/');lcd_putc('0'+__p);

			res_key=0;
		} // if( __p>=_BILDSERIE && __p<_LICHT )

		if(res_key & ( 1<<KEY_ESC) && __p!=_HAUPTMENU && __p!=_p_run)	
		{	__p=_HAUPTMENU;
			_p_run=0;
			res_key=0;
			menu();
		}
		
		if(res_key & ( 1<<KEY_ESC) && __p!=_HAUPTMENU && __p==_p_run)	
		{	_p_run=0;
			_prg_ph=0;
			SPEED_OFF;
			res_key=0;
		}

		if(res_key & ( 1<<KEY_ENTER ))
		{
			if( __p==_TIMERSETTING )
			{	p_tab=__p*10+_tab;
				switch(p_tab)
				{	case _11TIMSETDOWN1:
						_blinker=!_blinker;
						break;
					case 112:
						irPOWER(100);
						break;
					case _11TIMSETUP3:
						DCF_VCC_PORT ^= (1 << _dcfVCC);   		// VCC_DCF invert
						break;
					default:
						break;
				} // switch(p_tab)
				res_key=0;
			} // if( __p==_TIMERSETTING )


			if(__p==_POWERSTATUS)
			{	p8_stat=!p8_stat;			
				_PowerStatus();
				res_key=0;
			}

			if(__p==_UHR)
			{
				{
					if(DCF_LED_PORT & (1 << _dcfLED))
						DCF_LED_PORT &= ~(1 << _dcfLED);
					else
						DCF_LED_PORT |= (1 << _dcfLED);
						//DCF_LED_PORT ^= (1 << _dcfLED);
					res_key=0;
				}
			
				lcd_gotoxy(13,1);	lcd_putc(THETA); lcd_puts("="); lcd_puts(temperatur_str_rtc(-2)); lcd_puts("C"); // temperatur_str_rtc
	//ACHIM 
				if(DCF_LED_PORT&(1 << _dcfLED))
				{
					lcd_gotoxy(9,0); 
					lcd_puts(trimm_string(' ',itoa(alte_dcf77_period,  s, 10),3)); lcd_puts("/"); 
					lcd_puts(trimm_string(' ',itoa(alte_dcf77_pulse,  s, 10),2)); lcd_putc(RECHTS);
					lcd_puts(trimm_string(' ',itoa(dcf77count,  s, 10),4)); 
					lcd_gotoxy(1,1);  lcd_puts((char *)_uhr_string);
					lcd_gotoxy(0,3); lcd_puts("build  "); lcd_puts(t_bld);
					lcd_gotoxy(0,4); lcd_puts("DS3231 "); lcd_puts(t_rtc);
					lcd_gotoxy(1,5); (_time_i2c_rtc) ? lcd_puts("_time_i2c_rtc=TRUE") : lcd_puts("_time_i2c_rtc=FALSE");
				}
				else
				{	strcpy(s,"");
					lcd_gotoxy(9,0); lcd_puts(trimm_string(' ',s ,10));
					lcd_gotoxy(0,3); lcd_puts_p((char *)str_leerzeile);
					lcd_gotoxy(0,4); lcd_puts_p((char *)str_leerzeile);
					lcd_gotoxy(1,5); lcd_puts_p((char *)str_leerzeile);
					lcd_gotoxy(1,6); lcd_puts_p((char *)str_leerzeile);
				}

//---------------------------------------------------------------------------------------------------------
			lcd_gotoxy(6,0);(DCF_LED_PORT&(1 << _dcfLED)) ? lcd_puts("AN"):lcd_puts("  ");
//ACHIM	hier Uhrdesign ndern in Abhngigkeit von LED on/off		
				
			lcd_gotoxy(0,2); 
			if(_test_i2c_rtc && _rtc_d[2]>=7)
			{	lcd_puts(wt_str_rtc()); lcd_gotoxy(LCD_DISP_LENGTH-strlen(date_str_rtc(_NORMAL)),2); lcd_puts(date_str_rtc(_NORMAL));
			}
			else
			{	if(strlen( (char *)softdate._wochentag_)) lcd_puts( (char *)softdate._wochentag_);
				lcd_gotoxy(10,2); 
				if(strlen( (char *)softdate._date_)) lcd_puts( (char *)softdate._date_);
			}

//			lcd_gotoxy(0,7);lcd_puts((char *)UI_str);
//---------------------------------------------------------------------------------------------------------
				res_key=0;
			} // if(__p==_UHR)


			if(__p==_UHR_STATUS)
			{
				d_flag=!d_flag;
				res_key=0;
			}			
			
			if(__p==_IRSND)
			{	
				#include "if_p_irsnd.c"
				res_key=0;
			}

			if(__p==_KEY_TEST)
			{	do
				{
				res_key=get_key_press( ALL_KEYS );
				if( res_key )
				//while( res_key || get_key_rpt( ALL_KEYS ) )
				{	
					lcd_gotoxy(1,1); ( res_key & (1<<KEY_ESC)	) ? lcd_putc('1') : lcd_putc(' ');
					lcd_gotoxy(2,1); ( res_key & (1<<KEY_UP)	) ? lcd_putc('2') : lcd_putc(' ');
					lcd_gotoxy(3,1); ( res_key & (1<<KEY_LEFT)	) ? lcd_putc('3') : lcd_putc(' ');
					lcd_gotoxy(4,1); ( res_key & (1<<KEY_RIGHT)	) ? lcd_putc('4') : lcd_putc(' ');
					lcd_gotoxy(5,1); ( res_key & (1<<KEY_DOWN)	) ? lcd_putc('5') : lcd_putc(' ');
					lcd_gotoxy(6,1); ( res_key & (1<<KEY_ENTER)	) ? lcd_putc('6') : lcd_putc(' ');
	/*				lcd_gotoxy(7,1); ( res_key & (1<<KEY_7)	) ? lcd_putc('7') : lcd_putc(' ');
					lcd_gotoxy(8,1); ( res_key & (1<<KEY_8)	) ? lcd_putc('8') : lcd_putc(' ');
	*/
					//lcd_gotoxy(7,1); ( res_key & (1<<KEY7)	) ? lcd_putc('7') : lcd_putc(' ');
					//if(!res_key)
					//	lcd_puts("7");
	//				res_key=get_key_press( ALL_KEYS );
					if(( (res_key & ((1<<KEY_ESC)|(1<<KEY_UP)) ) == ((1<<KEY_ESC) | (1<<KEY_UP)) ) ||
						( (res_key & ((1<<KEY_UP)|(1<<KEY_LEFT)) ) == ((1<<KEY_UP) | (1<<KEY_LEFT)) ) ||
						( (res_key & ((1<<KEY_LEFT)|(1<<KEY_RIGHT)) ) == ((1<<KEY_LEFT) | (1<<KEY_RIGHT)) ) ||
						( (res_key & ((1<<KEY_RIGHT)|(1<<KEY_DOWN)) ) == ((1<<KEY_RIGHT) | (1<<KEY_DOWN)) ) ||
						( (res_key & ((1<<KEY_DOWN)|(1<<KEY_ENTER)) ) == ((1<<KEY_DOWN) | (1<<KEY_ENTER)) ) )
						{ __p=_HAUPTMENU; break; }
				}
			
				}
				while(__p);

				res_key=0;

				if(!__p) { res_key=0; menu();	}
			} // if(__p==_KEY_TEST)

			if(__p==__DCF77)
			{
				//lcd_gotoxy(1,1);
				if(upd_ms10_adc)
				//if(dcf77_period && dcf77_pulse)
				{
					// period 95-206 --- pulse 6-21
					lcd_gotoxy(14,0); lcd_puts(trimm_string(' ',itoa(dcf77count,  s, 10),3)); lcd_putc(' '); lcd_putc(SMILIE_NACHDENKLICH+dcf77error);			
					lcd_gotoxy(0,1); lcd_puts("period/pulse "); lcd_puts(trimm_string(' ',itoa(alte_dcf77_period,  s, 10),4)); lcd_puts("/"); lcd_puts(trimm_string(' ',itoa(alte_dcf77_pulse,  s, 10),3));
					//if (!dcf77error)
					{
						lcd_gotoxy(0,2); 
						lcd_puts(strWochentagname_kurz( newtime.wday ));
						lcd_puts(trimm_string(' ',itoa(newtime.day,  s, 10),2));
						lcd_puts(".");
						lcd_puts(trimm_string(' ',itoa(newtime.month,  s, 10),2));
						lcd_puts(".");
						lcd_puts(itoa(newtime.year+2000,  s, 10));
						lcd_puts(" "); 
						lcd_puts(trimm_string('0',itoa(newtime.hour,  s, 10),2));
						lcd_puts(":");
						lcd_puts(trimm_string('0',itoa(newtime.minute,  s, 10),2));
						lcd_puts(":");
						lcd_puts(trimm_string('0',itoa(0,  s, 10),2));
					}

						lcd_gotoxy(0,6); 
						lcd_puts(strWochentagname_kurz( time.wday ));
						lcd_puts(trimm_string(' ',itoa(time.day,  s, 10),2));
						lcd_puts(".");
						lcd_puts(trimm_string(' ',itoa(time.month,  s, 10),2));
						lcd_puts(".");
						lcd_puts(itoa(time.year+2000,  s, 10));
						lcd_puts(" "); 
						lcd_puts(trimm_string('0',itoa(time.hour,  s, 10),2));
						lcd_puts(":");
						lcd_puts(trimm_string('0',itoa(time.minute,  s, 10),2));
						lcd_puts(":00");

				}
				/*
				else
				{
					lcd_gotoxy(1,2); lcd_puts("dcf77_period= "); lcd_puts(trimm_string(' ',itoa(0,  s, 10),4));
					lcd_gotoxy(1,3); lcd_puts("dcf77_pulse=  "); lcd_puts(trimm_string(' ',itoa(0,  s, 10),4));
					lcd_gotoxy(1,4); lcd_puts("dcf77_time=   "); lcd_puts(trimm_string(' ',itoa(0,  s, 10),4));
				}
				*/
				lcd_gotoxy(5,1);
				lcd_gotoxy(6,1);
				res_key=0;
			}

		} // if(res_key & ( 1<<KEY_ENTER ))
		
		if(_p_run)
		{	switch(__p)
			{	case _BILDSERIE:
					_Bildserie();
					break;
				case _BEL_SERIE:
					_Bel_Serie();
					break;
				case _ZUFALLSBILDER:
					_Zufallsbilder();
					break;
				default:
					break;
			}
		} // if(_p_run)
		else
		{	if( __p==_BILDSERIE || __p==_BEL_SERIE || __p==_ZUFALLSBILDER || __p==_CAM_SETTINGS || __p==_UHRSTELLEN || __p==__RTC)
				if(res_key & (1<<KEY_LEFT) || res_key & (1<<KEY_RIGHT))
					__tab();
		} // else if(_p_run)

		if(__p==99)
			goto neustart;

		if(_p_run==_ZUFALLSBILDER && (_ms10==0 || _ms10==10 || _ms10==20 || _ms10==30 || _ms10==40 || _ms10==50 || _ms10==60 || _ms10==70 || _ms10==80 || _ms10==90))
		{ _Zufallsbilder(); lcd_gotoxy(10,2); lcd_puts(p3_cnt); }
/*
		if(__p!=_p_run)
			_p_run=_HAUPTMENU;		
*/
		if(__p==_HAUPTMENU || __p==_TIMERSETTING)
		{	while( (res_key & ( 1<<KEY_UP )) || get_key_rpt( 1<<KEY_UP ))
			{	scr_up();
				res_key=0;
			}
			while( (res_key & ( 1<<KEY_DOWN )) || get_key_rpt( 1<<KEY_DOWN ))
			{	scr_down();
				res_key=0;
			}
		} // if(__p==_HAUPTMENU || __p==_BILDSERIE)

		if(__p==_CHAR_SET)
		{	while( (res_key & ( 1<<KEY_UP )) || get_key_rpt( 1<<KEY_UP ))
			{	if(__i<255) 
					__i++;
				#if !LCD_CONTROLLER_KS0073
					switch(__i)
					{	case 8:
							__i=0x20;
							break;
						case 0x80:
							__i=0xa0;
							break;
						default:
							break;
					} // switch(__i)
				#endif
				res_key=0;
			} // while( (res_key & ( 1<<KEY_RIGHT )) || get_key_rpt( 1<<KEY_RIGHT ))
			
			while( (res_key & ( 1<<KEY_DOWN )) || get_key_rpt( 1<<KEY_DOWN ))
			{	if(__i>0) 
					__i--;
				#if !LCD_CONTROLLER_KS0073
					switch(__i)
					{	
						case 0x9f:
							__i=0x7f;
							break;
						case 0x1f:
							__i=7;
							break;
						default:
							break;
					} // switch(__i)
				#endif
				res_key=0;
			} // while( (res_key & ( 1<<KEY_LEFT )) || get_key_rpt( 1<<KEY_LEFT ))
			
			lcd_gotoxy(0,1); 
			lcd_puts(trimm_string(' ',itoa(__i,  s, 10),3)); lcd_putc(' '); 
			lcd_puts(trimm_string('0',itoa(__i,  s, 16),2)); lcd_putc(' ');
			lcd_putc(__i);
		} // if(__p==_CHAR_SET)

		if(__p==_POWERSTATUS)
		{	
			if(!p8_stat)
			{	lcd_gotoxy(14,0);lcd_putc('B');
				lcd_gotoxy(4,1); 	lcd_puts(trimm_string(' ',itoa(ReadChannel(UB),  s, 10),4)); lcd_puts("  ");
				lcd_gotoxy(14,1); 	lcd_puts(trimm_string(' ',itoa(ReadChannel(IBAT),  s, 10),4)); lcd_puts("  ");
				lcd_gotoxy(4,2); 	lcd_puts(trimm_string(' ',itoa(ReadChannel(LDR),  s, 10),4)); lcd_putc(' ');
			}
			else
			{	lcd_gotoxy(14,0);	lcd_putc('D');
				lcd_gotoxy(5,1); lcd_puts(insert_char( trimm_string('0',itoa( (ub * _scaler_BAT),  s, 10), 2 ), '.', 1)); 
				lcd_gotoxy(14,1); lcd_puts(trimm_string(' ',itoa(((ReadChannel(IBAT)  * _m_IVCC - _b_IVCC) ),  s, 10), 3 )); 
				lcd_gotoxy(5,2); lcd_puts(trimm_string(' ',itoa((UBYTE)(((ReadChannel(LDR)*100L/1023L)/5L)*5L),  s, 10),3));

			}
			lcd_gotoxy(14,4);	lcd_puts(trimm_string(' ',itoa( mAh/3600 ,  s, 10), 4 ));
			lcd_gotoxy(5,5); 	lcd_puts(trimm_string(' ', itoa(hg_led_get(),s,10), 3));	lcd_gotoxy(15,5); lcd_puts(trimm_string(' ', itoa(kon,s,10), 3));
		}
/*			
		if(__p==_STATUS)
		{  
			lcd_gotoxy(12,2); lcd_puts("dcfcnt"); lcd_puts(trimm_string('0',itoa(dcf.bitcnt,  s, 10),2));	
			lcd_gotoxy(18,1); lcd_puts(trimm_string('0',itoa(dcf.min,  s, 10),2));	
			lcd_gotoxy(18,0); 
			lcd_putc(softclock.dcf_set);
			lcd_gotoxy(4,2);  lcd_puts(trimm_all( (100*kon/_KON_PEEK), hg_led_get(), 3 ) ); 	
		} // if(__p==_STATUS)
*/

		if(__p==_IRMP)
		{	if (irmp_get_data(&irmp_data))
		   {
				sek10=0;
				wait_sec=20;
				if(irmp_data.protocol == IRMP_KASEIKYO_PROTOCOL)
					gelbLED(100);
				else
					gruenLED(100);

				lcd_gotoxy(0,1); lcd_puts("R: Code: "); lcd_puts(trimm_string(' ', irmp_protocol_names[irmp_data.protocol], 8));
				lcd_gotoxy(0,2); lcd_puts("A: "); 
				strcpy(s2, "0x"); strcat(s2, utoa(irmp_data.address,s,16)); lcd_puts(trimm_string(' ', s2, 6)); 
				strcpy(s2, "("); strcat(s2, utoa(irmp_data.address,s,10)); strcat(s2, "d)");
				lcd_gotoxy(11,2); lcd_puts(trimm_string(' ', s2, 8));
				
				lcd_gotoxy(0,3); lcd_puts("C: ");
				strcpy(s2, "0x"); strcat(s2, utoa(irmp_data.command,s,16));  lcd_puts(trimm_string(' ', s2, 6)); 
				strcpy(s2, "("); strcat(s2, utoa(irmp_data.command,s,10)); strcat(s2, "d)");
				lcd_gotoxy(11,3); lcd_puts(trimm_string(' ', s2, 8));
  		
				lcd_gotoxy(12,4); 
				if(irmp_data.protocol==IRMP_RC5_PROTOCOL)
				{	lcd_puts("("); lcd_puts(utoa((irmp_data.address*100+irmp_data.command),s,10)); lcd_puts(")");
				}
				else
					lcd_puts("          ");

				#if IRMP_LOGGING != 0       // 1: log IR signal (scan), 0: do not (default)
					strcpy(temp2,"# Code: "); strcat(temp2,trimm_string(' ', irmp_protocol_names[irmp_data.protocol], 8));
					strcat(temp2,", A: ");	strcat(temp2,utoa(irmp_data.address,s,16)); 
					strcat(temp2,", C: ");	strcat(temp2,utoa(irmp_data.command,s,16)); 
					strcat(temp2,"\r\n");
					
					if(strlen(temp2_bak)==0)
					uart_puts(temp2);
					if (strcmp(temp2, temp2_bak)!=0)
					{	strcpy(temp2_bak, temp2);
						uart_puts(temp2);
					}
				#endif
				while(irmp_get_data(&irmp_data));
			} // if (irmp_get_data(&irmp_data))
			
			if (wait_sec)
			{	lcd_gotoxy(16,0); lcd_puts(trimm_string(' ', itoa(wait_sec,s,10), 3));}
			else
			{	lcd_gotoxy(0,1); lcd_puts("R: Code:             ");
				lcd_gotoxy(0,2); lcd_puts("A:                   "); 
				lcd_gotoxy(0,3); lcd_puts("C:                   ");
				lcd_gotoxy(0,4); lcd_puts("                     ");
				lcd_gotoxy(16,0); lcd_puts(trimm_string(' ', itoa(0,s,10), 3));
				sek10=0;
			}
		} // if(__p==_IRMP)

		if(__p==_IRSND)
		{	
			if (wait_sec)
			{	lcd_gotoxy(16,0); lcd_puts(trimm_string(' ', itoa(wait_sec,s,10), 3));}
			else
			{	lcd_gotoxy(0,1); lcd_puts("R: Code:             ");
				lcd_gotoxy(0,2); lcd_puts("A:                   "); 
				lcd_gotoxy(0,3); lcd_puts("C:                   ");
				lcd_gotoxy(0,4); lcd_puts("                     ");
				lcd_gotoxy(16,0); lcd_puts(trimm_string(' ', itoa(0,s,10), 3));
				lcd_gotoxy(0,5); lcd_puts("sizeof(irmp_data) "); 
				lcd_gotoxy(0,6); lcd_puts(trimm_string(' ', utoa(sizeof(irmp_data),s,10), 6)); 
				sek10=0;
			}
		}

		if(__p==_UHRSTELLEN)
		{	
			lcd_gotoxy(0,LCD_LINES-3); lcd_puts( wt_str_rtc()); lcd_gotoxy(LCD_DISP_LENGTH-2-strlen(time_str_rtc()),LCD_LINES-3); lcd_puts(date_str_rtc(_NORMAL));
		}
/*
			if(new_stat_grenze==0)
			{	if(merke_dcf_msec_0>0 && merke_dcf_msec_1>0)
					new_stat_grenze=(merke_dcf_msec_0+merke_dcf_msec_1)/2;
			}
			else
			{	new_stat_grenze+=((merke_dcf_msec_0+merke_dcf_msec_1)/2);
				new_stat_grenze/=2;
				
				if(new_stat_grenze>10 && new_stat_grenze<15)
					_stat.sec_grenze=new_stat_grenze;
			}

			if( __p!=_HAUPTMENU / * && __p!=_POWERSTATUS * / && __p!=_UHR && __p!=_UHR_STATUS && !(KoHe_flag && (__p!=_STATUS)) )
			{ if(!(KoHe_flag && __p==_ZUFALLSBILDER)) { lcd_gotoxy(12,3); lcd_puts(time_str_rtc()); } }
*/
			// if(_ms10==16 || _ms10==50 || _ms10==83)
		
		if(!_p_run)
		{	p_tab=__p*10+_tab;
			switch(p_tab)
			//switch(__p)
			{	
				case _3VORLAUF:
					lcd_gotoxy(16,2); lcd_puts(trimm_string(' ',itoa(__vo1,  s, 10),3));lcd_putc('_');
					break;
				case _3ANZAHL: 
					lcd_gotoxy(16,3);  lcd_puts(trimm_string(' ',itoa(__bi1,  s, 10),3));lcd_putc('_');
					break;
				case _3ZW_ZEIT: 
					lcd_gotoxy(16,4); lcd_puts(trimm_string(' ',itoa(__zw1,  s, 10),3));lcd_putc('_');
					break;
				case _3BLINKER: 
					lcd_gotoxy(16,5); (_blinker) ? lcd_puts_p(str_an) : lcd_puts_p(str_aus); lcd_putc('_');
					break;
		
				case _4VORLAUF: 	//__vo2 Vorlauf 4.Bel.serie
					lcd_gotoxy(8,2); lcd_puts(trimm_string(' ',itoa(__vo2,  s, 10),3));lcd_putc('_');
					g_zeit=0;
					for(gz_cnt=0;gz_cnt<(__bi2);gz_cnt++)
						g_zeit+=( (1+_rausch) * ( (__zw2 << (gz_cnt*2) )/100) ) + __vo2;
					lcd_gotoxy(15,6); lcd_puts(trimm_string(' ',ultoa(g_zeit%60,  s2, 10),3));lcd_puts(" s");
					if(g_zeit/60>0)
					{ lcd_gotoxy(8,6); lcd_puts(trimm_string(' ',ultoa(g_zeit/60,  s2, 10),3));lcd_puts(" min"); }
					else
					{ lcd_gotoxy(8,6); lcd_puts("       "); }
					break;
				case _4ANZAHL: 
					lcd_gotoxy(9,3);  lcd_puts(trimm_string(' ',itoa(__bi2,  s, 10),2));lcd_putc('_');
					//hilf_=__zw2;
					hilf_=pgm_read_word(zeit[__tv])/10;
					hilf_<<=((__bi2-1));

					lcd_gotoxy(15,5); 
					if( hilf_< (ULONG)100)
					{ 	strcpy(s,"1/"); 
						strcat(s,ultoa(100/(__zw2 << ((__bi2-1))),  s2, 10));
						strcat(s,"s");lcd_gotoxy(11,5); lcd_puts(trimm_string(' ',s,5));
					}
					else
					{	lcd_puts(trimm_string(' ',ultoa(((__zw2 << ((__bi2-1)))/100)%60,  s, 10),3)); lcd_puts(" s");
						if(((__zw2 << ((__bi2-1)))/100)/60>0)
						{ lcd_gotoxy(8,5); lcd_puts(trimm_string(' ',ultoa(((__zw2 << ((__bi2-1)))/100)/60,  s, 10),3)); lcd_puts(" min"); }
						else
						{	lcd_gotoxy(8,5); lcd_puts("       "); }
					}
					g_zeit=0;
					for(gz_cnt=0;gz_cnt<(__bi2);gz_cnt++)
						g_zeit+=( (1+_rausch) * ( (__zw2 << (gz_cnt*2) )/100) ) + __vo2;
					lcd_gotoxy(15,6); lcd_puts(trimm_string(' ',ultoa(g_zeit%60,  s2, 10),3));lcd_puts(" s");
					if(g_zeit/60>0)
					{ lcd_gotoxy(8,6); lcd_puts(trimm_string(' ',ultoa(g_zeit/60,  s2, 10),3));lcd_puts(" min"); }
					else
					{ lcd_gotoxy(8,6); lcd_puts("       "); }
					break;
				case _4TV_ANF_ZEIT: 
					lcd_gotoxy(15,2); strcpy_P(s, (PGM_P)zeit_str[__tv]);	lcd_puts(trimm_string(' ',s,5)); lcd_putc('_');


					 
					hilf_=__zw2;
					hilf_<<=((__bi2-1));

					lcd_gotoxy(15,5); 
					if( hilf_< (ULONG)100)
					{ 	strcpy(s,"1/"); 
						strcat(s,ultoa(100/(__zw2 << ((__bi2-1))),  s2, 10));
						strcat(s,"s");lcd_gotoxy(11,5); lcd_puts(trimm_string(' ',s,5));
					}
					else
					{	lcd_puts(trimm_string(' ',ultoa(((__zw2 << ((__bi2-1)))/100)%60,  s, 10),3)); lcd_puts(" s");
						if(((__zw2 << ((__bi2-1)))/100)/60>0)
						{ lcd_gotoxy(8,5); lcd_puts(trimm_string(' ',ultoa(((__zw2 << ((__bi2-1)))/100)/60,  s, 10),3)); lcd_puts(" min"); }
						else
						{ lcd_gotoxy(8,5); lcd_puts("       "); }
					}
					g_zeit=0;
					for(gz_cnt=0;gz_cnt<(__bi2);gz_cnt++)
						g_zeit+=( (1+_rausch) * ( (__zw2 << (gz_cnt*2) )/100) ) + __vo2;
					lcd_gotoxy(15,6); lcd_puts(trimm_string(' ',ultoa(g_zeit%60,  s2, 10),3));lcd_puts(" s");
					if(g_zeit/60>0)
					{ lcd_gotoxy(8,6); lcd_puts(trimm_string(' ',ultoa(g_zeit/60,  s2, 10),3));lcd_puts(" min"); }
					else
					{ lcd_gotoxy(8,6); lcd_puts("       "); }
					break;
				case _4SVA: // __sva
					lcd_gotoxy(5,1); (__sva) ? lcd_putc('1') : lcd_putc('0'); lcd_putc('_');
					break;
				case _4RAUSCH: // _rausch
					lcd_gotoxy(19,1); (_rausch) ? lcd_putc('1') : lcd_putc('0'); lcd_putc('_');
					g_zeit=0;
					for(gz_cnt=0;gz_cnt<(__bi2);gz_cnt++)
						g_zeit+=( (1+_rausch) * ( (__zw2 << (gz_cnt*2) )/100) ) + __vo2;
					lcd_gotoxy(15,6); lcd_puts(trimm_string(' ',ultoa(g_zeit%60,  s2, 10),3));lcd_puts(" s");
					if(g_zeit/60>0)
					{ lcd_gotoxy(8,6); lcd_puts(trimm_string(' ',ultoa(g_zeit/60,  s2, 10),3));lcd_puts(" min"); }
					else
					{ lcd_gotoxy(8,6); lcd_puts("       "); }
					break;
				case _4AV: // __sva
					utoa(pgm_read_byte((char*)blenden+__f),  s2, 10);
					lcd_gotoxy(15,3); 
					if(strlen(s2)<3)
						lcd_puts(trimm_string(' ',insert_char(s2, '.', 1),5));
					else					
					{	lcd_puts(trimm_string(' ',lefts(s2,2),4)); lcd_putc(' '); }
					lcd_putc('_'); 

//insert_char( trimm_string('0',itoa( (ub * _scaler_BAT),  s, 10), 2 ), '.', 1));
					
					break;

				case _5RANDOM:
					lcd_gotoxy(11,2); lcd_puts(trimm_string(' ',itoa(__we,  s, 10),3));lcd_putc('_');
					break;

				case _7CAM_SVA:
					lcd_gotoxy(4,1); 
					(__sva==1) ? lcd_puts(" AN") : lcd_puts("AUS");	
					lcd_putc('_');
					break;

				case _7CAM_RAUSCH: 
					lcd_gotoxy(16,1);
					(!_rausch) ? lcd_puts("AUS_") : lcd_puts("AN_");
					break;

				case _7CAM_APOWER: 
					lcd_gotoxy(13,2); 
					switch(_autopower)
					{	case 0:
							lcd_puts("AUS_   ");
							break;
						case 1:
						case 2:
						case 4:
						case 8:
							lcd_puts(trimm_string(' ',itoa(_autopower,  s, 10),3));lcd_putc('_');lcd_puts("min");
							break;
						case 15:
							lcd_puts(" 15_min");
							break;
						case 30:
							lcd_puts(" 30_min");
							break;
					}
					break;

				case _15HOUR: 
					lcd_gotoxy(LCD_DISP_LENGTH-8,LCD_LINES-2);	lcd_putc(RUNTER);lcd_putc(RUNTER);
					break;
				case _15MINUTE: 
					lcd_gotoxy(LCD_DISP_LENGTH-5,LCD_LINES-2);	lcd_putc(RUNTER);lcd_putc(RUNTER);
					break;
				case _15DATE: 
					lcd_gotoxy(LCD_DISP_LENGTH-10,LCD_LINES-2);	lcd_putc(RAUF);lcd_putc(RAUF);
					break;
				case _15MONTH: 
					lcd_gotoxy(LCD_DISP_LENGTH-7,LCD_LINES-2);	lcd_putc(RAUF);lcd_putc(RAUF);
					break;
				case _15YEAR: 
					lcd_gotoxy(LCD_DISP_LENGTH-4,LCD_LINES-2);	lcd_putc(RAUF);lcd_putc(RAUF); lcd_putc(RAUF);lcd_putc(RAUF);
					break;

			} // switch(p_tab)
		} // if(!_p_run)
		
		if(__p!=_HAUPTMENU)
		{	if( __p!=_BILDSERIE && __p!=_BEL_SERIE && __p!=_ZUFALLSBILDER && __p!=_CAM_SETTINGS && __p!=_TIMERSETTING && __p!=_CHAR_SET && __p!=_KEY_TEST  && __p!=_UHRSTELLEN && __p!=__RTC )
			{	if( (res_key & ( 1<<KEY_UP )) || get_key_rpt( 1<<KEY_UP ))
				{	res_key=0;
					hg_led_plus();
				}
				if( (res_key & ( 1<<KEY_DOWN )) || get_key_rpt( 1<<KEY_DOWN ))
				{	res_key=0;
					hg_led_minus();
				}
				if( (res_key & ( 1<<KEY_LEFT )) || get_key_rpt( 1<<KEY_LEFT ))
				{	res_key=0;
					kon_minus();
				}
				if( (res_key & ( 1<<KEY_RIGHT )) || get_key_rpt( 1<<KEY_RIGHT ))
				{	res_key=0;
					kon_plus();
				}
			} // if( __p!=_BILDSERIE && __p!=_BEL_SERIE && __p!=_ZUFALLSBILDER && __p!=_CAM_SETTINGS && __p!=_TIMERSETTING && __p!=_CHAR_SET && __p!=_KEY_TEST  && __p!=_UHRSTELLEN )

			if( __p==_BILDSERIE || __p==_BEL_SERIE || __p==_ZUFALLSBILDER || __p==_CAM_SETTINGS || __p==_UHRSTELLEN )
			{	while( (res_key & ( 1<<KEY_UP )) || get_key_rpt( 1<<KEY_UP ))
				{	p_tab=__p*10+_tab;
					switch(p_tab)
					{	case _3VORLAUF: //VO 
							if(__vo1<255)
								__vo1++;
							break;
						case _4TV_ANF_ZEIT: //VO 
							if(__tv<_CAM_MAX_TV)
							{	__tv++;
								if(__tv<21)
									__zw2=pgm_read_word(&zeit[__tv])/10;
								else
									__zw2=pgm_read_word(&zeit[__tv])*10;
							}
							break;
						case _3ANZAHL: //BI
							if(__bi1<99)
								__bi1++;
							break;
						case _4ANZAHL: //BI
							if(__bi2<99)
								__bi2++;
							break;
						case _4AV: // __sva
							if(pgm_read_byte(&blenden[__f])<_CAM_MAXBLENDE)
								__f++;
							break;
						case _3ZW_ZEIT: //ZW 
							if(__zw1<99)
								__zw1++;
							break;
						case _3BLINKER: 
							_blinker=!_blinker;
							break;
						case _4VORLAUF: 	//__vo2 Vorlauf 4.Bel.serie
							if(__vo2<99)
								__vo2++;
							break;
						case _4SVA: //SVA 
							if(!__sva)
								__sva=TRUE;
							break;
						case _4RAUSCH: // _rausch
							if(!_rausch)
								_rausch++;
							break;

						case _7CAM_SVA: //SVA 
							if(!__sva)
								__sva=TRUE;
							break;
						case _7CAM_RAUSCH: 
							if(_rausch<1)
								_rausch++;
							break;
						case _7CAM_APOWER: 
							if(_autopower<30)
								_autopower*=2;
							if(_autopower==16)
								_autopower=15;
							if(_autopower==0)
								_autopower=1;
							break;

						case _11TIMSETUP2:
						case _11TIMSETUP3:
							scr_up();							
							break;
						
						case _15HOUR: 
							if(__hour<23)
								__hour++;
							else
								__hour=0;
							write_rtc( HOURS, int2bcd(__hour) );
							_uhr_go=TRUE;							
							read_rtcTD();
							break;
						case _15MINUTE: 
							if(__minute<59)
								__minute++;
							else
								__minute=0;
							write_rtc( MINUTES, int2bcd(__minute) );
							_uhr_go=TRUE;							
							read_rtcTD();
							break;
						case _15DATE: 
							if(__day<Monatstage( __year, __month ))
								__day++;
							else
								__day=1;
							write_rtc( DATE, int2bcd(__day) );
							write_rtc( DAY, wochentag_im_jahr(__year, tagesnummer( __year, __month, __day )));
							_uhr_go=TRUE;							
							read_rtcTD();
							break;
						case _15MONTH: 
							if(__month<12)
								__month++;
							else
								__month=1;
							
							if(__year>1999)
								write_rtc( C_MONTH,(int2bcd(__month)|(1<<CENTURY)) );
							else
								write_rtc( C_MONTH,int2bcd(__month) );
							
							write_rtc( DAY, wochentag_im_jahr(__year, tagesnummer( __year, __month, __day )));
							_uhr_go=TRUE;							
							read_rtcTD();
							break;
						case _15YEAR: 
							if(__year<2099)
								__year++;
							else
								__year=2011;
							if(__year>1999)
							{	write_rtc( C_MONTH,(int2bcd(__month)|(1<<CENTURY)) );
								write_rtc( YEAR, int2bcd(__year-2000) );
							}
							else
							{	write_rtc( C_MONTH,int2bcd(__month) );
								write_rtc( YEAR, int2bcd(__year-1900) );
							}
							write_rtc( DAY, wochentag_im_jahr(__year, tagesnummer( __year, __month, __day )));
							_uhr_go=TRUE;							
							read_rtcTD();
							break;

					} // switch(p_tab)
					//res_key=get_key_press( ALL_KEYS );
					//res_key=get_key_press( (1<<KEY_UP) );
				} // while( (res_key & ( 1<<KEY_LEFT )) == ( 1<<KEY_LEFT ) || get_key_rpt( 1<<KEY_LEFT ))

				while( (res_key & ( 1<<KEY_DOWN )) || get_key_rpt( 1<<KEY_DOWN ))
				{	p_tab=__p*10+_tab;
				 	switch(p_tab)
					{	case _3VORLAUF: //VO
							if(__vo1>0)
								__vo1--;
							break;
						case _4TV_ANF_ZEIT: //VO
							if(__tv>0)
							{	__tv--;
								if(__tv<21)
									__zw2=pgm_read_word(&zeit[__tv])/10;
								else
									__zw2=pgm_read_word(&zeit[__tv])*10;
							}
							break;
						case _3ANZAHL: //BI 
							if(__bi1>1)
								__bi1--;
							break;
						case _3BLINKER: 
							_blinker=!_blinker;
							break;
						case _4ANZAHL: //BI
							if(__bi2>1)
								__bi2--;
							break;
						case _3ZW_ZEIT: //ZW 
							if(__zw1>=1)
								__zw1--;
							break;
						case _4VORLAUF: 	//__vo2 Vorlauf 4.Bel.serie
							if(__vo2>=1)
								__vo2--;
							break;
						case _4SVA: // __sva 
							if(__sva)
								__sva=FALSE;
							break;
						case _4RAUSCH: // _rausch
							if(_rausch)
								_rausch--;
							break;
						case _4AV: // __sva
							if(__f>0)
								__f--;
							break;

						case _7CAM_SVA: //SVA 
							if(__sva)
								__sva=FALSE;
							break;
						case _7CAM_RAUSCH: 
							if(_rausch>0)
								_rausch--;
							break;
						case _7CAM_APOWER: 
							if(_autopower>0)
								_autopower/=2;
							if(_autopower==7)
								_autopower=8;
							break;

						case _11TIMSETDOWN1: 
						case _11TIMSETDOWN2: 
							scr_down();							
							break;

						case _15HOUR: 
							if(__hour>=1)
								__hour--;
							write_rtc( HOURS, int2bcd(__hour) );
							_uhr_go=TRUE;							
							read_rtcTD();
							break;
						case _15MINUTE: 
							if(__minute>=1)
								__minute--;
							write_rtc( MINUTES, int2bcd(__minute) );
							_uhr_go=TRUE;							
							read_rtcTD();
							break;
						case _15DATE: 
							if(__day>1)
								__day--;
							write_rtc( DATE, int2bcd(__day) );
							write_rtc( DAY, wochentag_im_jahr(__year, tagesnummer( __year, __month, __day )));
							_uhr_go=TRUE;							
							read_rtcTD();
							break;
						case _15MONTH: 
							if(__month>1)
								__month--;
							if(__year>1999)
								write_rtc( C_MONTH,(int2bcd(__month)|(1<<CENTURY)) );
							else
								write_rtc( C_MONTH,int2bcd(__month) );
							write_rtc( DAY, wochentag_im_jahr(__year, tagesnummer( __year, __month, __day )));
							_uhr_go=TRUE;							
							read_rtcTD();
							break;
						case _15YEAR: 
							if(__year>2011)
								__year--;
							if(__year<2000)
							{	write_rtc( C_MONTH,int2bcd(__month) );
								write_rtc( YEAR, int2bcd(__year-1900) );
							}
							else
							{	write_rtc( C_MONTH,(int2bcd(__month)|(1<<CENTURY)) );
								write_rtc( YEAR, int2bcd(__year-2000) );
							}
							write_rtc( DAY, wochentag_im_jahr(__year, tagesnummer( __year, __month, __day )));
							_uhr_go=TRUE;							
							read_rtcTD();
							break;
					} // switch(p_tab)
					//res_key=get_key_press( ALL_KEYS );
					//res_key=get_key_press( (1<<KEY_DOWN) );
				} // while( (res_key & ( 1<<KEY_RIGHT )) == ( 1<<KEY_RIGHT ) || get_key_rpt( 1<<KEY_RIGHT ))
			} // if( __p==_BILDSERIE || __p==_BEL_SERIE || __p==_ZUFALLSBILDER || __p==_CAM_SETTINGS || __p==_UHRSTELLEN )
			if(_uhr_go)
				strcpy((char *)_uhr_string, "gestellt  ");


		} // if(__p!=_HAUPTMENU)

		if(KoHe_flag && __p!=_HAUPTMENU)
		{		if(last_kohe=='H')
					{ lcd_gotoxy(12,7);  lcd_puts("   H "); lcd_puts( trimm_string(' ', itoa(hg_led_get(), s, 10), 3)); lcd_puts("%");}
				if(last_kohe=='K')
					{ lcd_gotoxy(12,7);  lcd_puts("   K "); lcd_puts( trimm_string(' ', itoa(kon, s, 10), 3)); lcd_puts("%");}
		}
/*
		if(!bedient)
		{
			if(off==0)
			{
				if((UBYTE)(((ReadChannel(LDR)*100L/1023L)/5L)*5L)<10 / *&& (ubat>5)* /)
					off=BATT_OFF;
				else
					off=NORMAL_OFF;
			}

			if(cpu_idle>=off)
			{
				alarm1_clr_rtc();
				woher=shutdown(SLEEP_MODE_PWR_DOWN);
				//goto neustart;
			}
			if(__p==_UHR && cpu_idle>30)
			{ lcd_gotoxy(7,0);  lcd_puts(" aus "); lcd_puts( trimm_string(' ', itoa((off-cpu_idle), s, 10), 4)); lcd_puts("s");}

		}
*/
		if(__p==_BEEP)
		{	__p=_HAUPTMENU; _p_run=_HAUPTMENU;}

/*
		if(!_i2c_key)
			if (sek10>=5)
			{	
				sek10=0;
				irPOWER(ON); // zur Sicherheit, solange kein KEY: RESET IR off
			} // if (sek10==15)
*/
		flags_abarbeiten();
		
		if(__p!=_POWERSTATUS)
			if(!wait_hell_flag)
			{
				if( (_hell_perc < 40) && (hg_led_get() < 10) && _ibat<104) // wenn zu dunkel und kein HG_LED -> HG_LED auf minimum
					hg_led_set(10);
				if(_ibat>104) // 1mA
					if( (_hell_perc > 75) && (hg_led_get() > 0) ) // wenn sehr hell und HG_LED -> HG_LED aus
						hg_led_set(0);
			}

		if( __p>=_BILDSERIE && __p<_LICHT && _p_run!=__p )
		{
//			lcd_gotoxy(LCD_DISP_LENGTH-10,0); lcd_puts(trimm_string(' ',itoa(__tv,  s, 10),2)); lcd_putc('!');
			lcd_gotoxy(LCD_DISP_LENGTH-6,0); lcd_puts(trimm_string(' ',itoa(p_tab,  s, 10),3)); lcd_putc('!'); //jar
		}
/*

	lcd_gotoxy(7,0); 
	lcd_puts("__p="); 
	lcd_puts(itoa(__p, (char *)s,10)); 
	lcd_puts("_p_run="); 
	lcd_puts(itoa(_p_run, (char *)s,10));

	lcd_gotoxy(14,6); 
	lcd_puts(itoa((1+ext_h_beginn_),(char *)s,10));

	lcd_gotoxy(17,6); 
	lcd_puts(itoa((line_-1),(char *)s,10));
	lcd_puts("/");
	lcd_puts(itoa((beginn_),(char *)s,10));

	if(__p==_TIMERSETTING)
	{
		lcd_gotoxy(17,6); 
		lcd_puts(itoa((h_line_p10),(char *)s,10));
		lcd_puts("/");
		lcd_puts(itoa((h_beginn_p10),(char *)s,10));
	}
*/
		res_key=0;

/*
		lcd_gotoxy(19,0); 
		lcd_putc('0'+_p_run);
		bli(_ONCE);
*/
	} // for (;;)
}


